﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AlienBehavior : MonoBehaviour {

	private Rigidbody2D rb;
	private Transform curTransform;
    private SpriteRenderer sprite;
    public Animator animator;
    private bool toggle;
    private bool coroutineRunning;
    private int targetY;
    private int targetX = 10;

    private AudioSource soundMaker;
    public AudioClip breakWall;

    void OnEnable() {
        if (toggle == true){
            ResetAlien();
        }
    }

    void OnDisable() {
        if (toggle == true){
            //sprite.material.SetColor ("_Color", new Color(1f, 1f, 1f, 0f));
        }
    }

    void Awake(){
        rb = GetComponent<Rigidbody2D>();
        sprite = this.GetComponent<SpriteRenderer>();
        curTransform = this.transform;
        animator = this.GetComponent<Animator>();
        soundMaker = GameObject.Find("Audio Source").GetComponent<AudioSource>();
    }

    // Start is called before the first frame update
    void Start(){
        toggle = true;
        ResetAlien();
    }

    void Update(){
        if (GenerateWorld.instance.GameOver == false){
        	rb.position = Vector2.MoveTowards(rb.position, new Vector2(targetX, targetY), 0.05f);
            setTarget();
            if (rb.position == new Vector2(targetX, targetY) && coroutineRunning == false){
                StartCoroutine(DeathAnimation());
                coroutineRunning = true;
            }
        }
    }

    IEnumerator DeathAnimation (){
        animator.SetInteger("movement", 1);
        if (GenerateWorld.instance.GameOver == false)
            soundMaker.PlayOneShot(breakWall);
        yield return new WaitForSeconds (1f);
        GenerateWorld.instance.DamageLevee(targetX - 10, targetY);
        sprite.material.SetColor ("_Color", new Color(1f, 1f, 1f, 0f));
        curTransform.position = new Vector2(-5, targetY);
        ObjectPool.instance.PoolObject(rb.gameObject);
    }

    void ResetAlien(){
        targetY = Random.Range (0, 10);
        curTransform.position = new Vector2(-5, targetY);
        animator.SetInteger("movement", 0);
        coroutineRunning = false;
        sprite.material.SetColor ("_Color", new Color(1f, 1f, 1f, 1f));
        setTarget();
    }

    void setTarget(){
         if (GenerateWorld.instance.Grid[targetY][0] > 0)
            targetX = 10;
        else if (GenerateWorld.instance.Grid[targetY][1] > 0)
            targetX = 11;
        else
            targetX = 12;
    }

}
