﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RobotBehavior : MonoBehaviour{

	private Camera levelCam;
	private Rigidbody2D rb;
	public Animator animator;
	private int targetX;
	private int targetY;
	private bool toggle;
	public int mouseButton;

    // Start is called before the first frame update
    void Awake(){
        levelCam = GameObject.Find("Main Camera").GetComponent<Camera>();
        rb = GetComponent<Rigidbody2D>();
        animator = this.GetComponent<Animator>();
    }

    // Update is called once per frame
     void Update(){
        if (Input.GetMouseButtonDown(mouseButton)){
        	Vector3 worldPoint = Camera.main.ScreenToWorldPoint(Input.mousePosition);
			Vector2 worldPoint2d = new Vector2((int)(worldPoint.x + 0.5f), (int)(worldPoint.y + 0.5f));
			if ((int)worldPoint2d.y >= 0 && (int)worldPoint2d.y < 10 && (int)worldPoint2d.x - 10 >= 0 && (int)worldPoint2d.x - 10 <= 2){
				//Debug.Log(GenerateWorld.instance.Grid[(int)worldPoint2d.y][(int)(worldPoint2d.x - 10)]);
				targetX = (int)worldPoint2d.x;
				targetY = (int)worldPoint2d.y;
				toggle = true;
			}
        }
        if(toggle == true){
        	rb.position = Vector2.MoveTowards(rb.position, new Vector2(targetX, targetY), 0.01f);
	        if(rb.position == new Vector2(targetX, targetY)){
	        	animator.SetInteger("movement", 0);
	        	GenerateWorld.instance.RepairLevee(targetX - 10, targetY);
	        }
	        else
	        	animator.SetInteger("movement", 1);
	    }
    }
}
